#!/usr/bin/env node
var minimist = require('minimist');
var extend = require('xtend');
var cli_1 = require('../utils/cli');
var config_1 = require('../utils/config');
var dependencies_1 = require('../lib/dependencies');
var args = minimist(process.argv.slice(2), {
    boolean: ['verbose', 'help', 'ambient', 'production'],
    alias: {
        verbose: ['v'],
        ambient: ['a'],
        help: ['h']
    }
});
if (args.help) {
    console.log("\n" + config_1.PROJECT_NAME + " ls [--ambient] [--production]\n\nAliases: la, ll, list\n");
    process.exit(0);
}
var cwd = process.cwd();
var options = extend(args, { cwd: cwd });
cli_1.loader(dependencies_1.resolveTypeDependencies({ cwd: cwd, ambient: true, dev: !args.production }), options)
    .then(function (tree) {
    console.log(cli_1.archifyDependencyTree(tree, { ambient: true, dev: true }));
});
//# sourceMappingURL=typings-list.js.map