var Promise = require('native-or-bluebird');
var path_1 = require('path');
var fs_1 = require('./utils/fs');
var config_1 = require('./utils/config');
var DEFAULT_CONFIG = {
    dependencies: {},
    devDependencies: {}
};
function init(options) {
    var path = path_1.join(options.cwd, config_1.CONFIG_FILE);
    return fs_1.isFile(path)
        .then(function (exists) {
        if (exists) {
            return Promise.reject(new Error("A " + config_1.CONFIG_FILE + " file already exists"));
        }
        return fs_1.writeJson(path, DEFAULT_CONFIG, 2);
    });
}
exports.init = init;
//# sourceMappingURL=init.js.map