var path_1 = require('path');
var Promise = require('native-or-bluebird');
var fs_1 = require('../utils/fs');
var config_1 = require('./config');
function findProject(dir) {
    return findConfigFile(dir).then(path_1.dirname);
}
exports.findProject = findProject;
function findConfigFile(dir) {
    return findUp(dir, config_1.CONFIG_FILE);
}
exports.findConfigFile = findConfigFile;
function findUpParent(dir, filename) {
    var parentDir = path_1.dirname(dir);
    if (dir === parentDir) {
        return Promise.reject(new Error("Unable to resolve " + filename));
    }
    return findUp(parentDir, filename);
}
exports.findUpParent = findUpParent;
function findUp(dir, filename) {
    var path = path_1.join(dir, filename);
    return fs_1.isFile(path)
        .then(function (exists) {
        return exists ? path : findUpParent(dir, filename);
    });
}
exports.findUp = findUp;
//# sourceMappingURL=find.js.map