import * as fs from 'graceful-fs';
import Promise = require('native-or-bluebird');
import lockfile = require('lockfile');
import { ConfigJson } from '../interfaces/main';
export declare type Stats = fs.Stats;
export declare const stat: (a: string) => Promise<fs.Stats>;
export declare const readFile: (a: string, b: string) => Promise<string>;
export declare const writeFile: (a: string, b: string | Buffer) => Promise<void>;
export declare const mkdirp: (a: string) => Promise<void>;
export declare const unlink: (a: string) => Promise<void>;
export declare const lock: (a: string, b: lockfile.Options) => Promise<void>;
export declare const unlock: (a: string) => Promise<{}>;
export declare function isFile(path: string): Promise<boolean>;
export declare function readJson(path: string): Promise<any>;
export declare function writeJson(path: string, json: any, indent?: string | number): Promise<void>;
export declare function readConfig(path: string): Promise<ConfigJson>;
export declare function readConfigFrom(path: string): Promise<ConfigJson>;
export declare function parseConfig(config: ConfigJson, path: string): ConfigJson;
export declare function readHttp(url: string): Promise<string>;
export declare function readFileFrom(from: string): Promise<string>;
export declare function readJsonFrom(from: string): Promise<any>;
export declare function parseJson(contents: string, path: string): any;
export declare function transformFile(path: string, transform: (contents: string) => string | Promise<string>): Promise<any>;
export declare function transformJson<T>(path: string, transform: (json: T) => T): Promise<any>;
export declare function transformConfig(cwd: string, transform: (config: ConfigJson) => ConfigJson): Promise<any>;
export declare function transformDtsFile(path: string, transform: (typings: string[]) => string[]): Promise<any>;
export interface DefinitionOptions {
    cwd: string;
    name: string;
    ambient: boolean;
}
export declare function writeDependency(contents: {
    main: string;
    browser: string;
}, options: DefinitionOptions): Promise<boolean>;
export declare function removeDependency(options: DefinitionOptions): Promise<any>;
